--

generic

package Buffers.Mailboxes is

   type Buffers_Store_Array_Type is array (Positive range <>) of Element_Type;

   protected type Mailbox_Type (Max_Capacity : Positive) is new Buffer_Type with
      overriding entry Put (Item : in Element_Type);
      overriding entry Get (Item : out Element_Type);

   private
      First            : Positive := Positive'First;
      Last             : Positive := Max_Capacity;
      Elements_In_Buffer : Natural  := Natural'First;

      Box_Store : Buffers_Store_Array_Type (Positive'First .. Max_Capacity);

   end Mailbox_Type;

end Buffers.Mailboxes;
