--

with Futures;
with Callables;

generic

package Executors.Completion_Services is

   type Completion_Service_Type is limited interface and Executors.Executor_Type;

   overriding procedure Submit
     (Exec      : in out Completion_Service_Type;
      Command   : in     Executors.My_Callables.Any_Callable_Access_Type;
      Params    : in     Parameter_Type;
      My_Future : in     Executors.My_Futures.Any_Future_Access_Type) is abstract;

   procedure Take
     (Exec      : in out Completion_Service_Type;
      My_Future :    out Executors.My_Futures.Any_Future_Access_Type) is abstract;

   type Any_Completion_Service_Access_Type is access all Completion_Service_Type'Class;

end Executors.Completion_Services;
